// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnlibs.hpp"
#include "display/RenderManager.hpp"
#include "scene/Scene.hpp"
#include "scene/components/Components.hpp"

namespace Dawn {
  class RenderPipeline {
    public:
      RenderManager &renderManager;

      RenderPipeline(RenderManager &renderManager);
      virtual void init();
      void render();
      virtual void renderScene(Scene &scene) = 0;
      virtual void renderSceneCamera(Scene &scene, Camera &camera) = 0;
      virtual ~RenderPipeline();
  };
}