// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "display/shader/Shader.hpp"

namespace Dawn {
  class Shader;
  
  class Material : public SceneItemComponent {
    friend class RenderPipeline;

    private:
      std::shared_ptr<Shader> shader;

      void updateShaderParameters();


    public:
      std::map<shaderparameter_t, enum ShaderParameterType> parameters;

      std::map<shaderparameter_t, struct Color> colorValues;
      std::map<shaderparameter_t, bool_t> boolValues;
      std::map<shaderparameter_t, glm::mat4> matrixValues;
      std::map<shaderparameter_t, glm::vec3> vec3Values;

      Material(SceneItem &item);

      std::shared_ptr<Shader> getShader();
      void setShader(std::shared_ptr<Shader> shader);

      void setShaderParameters();

      void start() override;
  };
}